unit classMSTeam;

interface

uses
  System.SysUtils,
  System.Classes,
  IdSSLOpenSSL, IdHTTP,
  IdContext, vcl.Dialogs;


type
  TvsMSTeam = class
  private
    FWebhookUrl : string;
    FHTTP: TIdHTTP;
    FSSL : TIdSSLIOHandlerSocketOpenSSL;
    // FMessage : TStringList;
    // procedure init;
  protected
  public
    property WebhookUrl : string read FWebhookUrl write FWebhookUrl;
    constructor Create;
    destructor Destroy; override;
    function SendCard(const pCard: string): string;
    function SendMessage(pMsg : string) : string;
  end;


implementation


constructor TvsMSTeam.Create;
begin
  FHTTP:= TIdHTTP.Create(nil);
  FSSL := TIdSSLIOHandlerSocketOpenSSL.Create(nil);
  FSSL.SSLOptions.Mode := sslmClient;
  FHTTP.IOHandler := FSSL;

end;

destructor TvsMSTeam.Destroy;
begin
  FHTTP.Free;
  FSSL.Destroy;
  inherited;
end;


function TvsMSTeam.SendMessage(pMsg: string): string;
var
  Params   : TStringStream;
  LMsg: string;
begin

  LMsg := '{"text": "'+pMsg+'"}';

  Result := '';

  Params := TStringStream.Create(LMsg, TEncoding.UTF8);
  try
    FHTTP.Request.ContentEncoding := 'gzip';
    FHTTP.Request.UserAgent      := 'PostmanRuntime/7.1.1';
    FHTTP.Request.ContentType := 'application/json';
    FHTTP.Request.CharSet := 'utf-8';

    Result := FHTTP.Post(FWebhookUrl, Params);
  except
    on E: Exception do Result := e.Message;
  end;
  Params.Free;

end;

function TvsMSTeam.SendCard(const pCard: string): string;
var
  Params   : TStringStream;
begin
  // + EOL +

  Result := '';

  Params := TStringStream.Create(pCard, TEncoding.UTF8);
  try
    FHTTP.Request.ContentEncoding := 'gzip';
    FHTTP.Request.UserAgent      := 'PostmanRuntime/7.1.1';
    FHTTP.Request.ContentType := 'application/json';
    FHTTP.Request.CharSet := 'utf-8';

    Result := FHTTP.Post(FWebhookUrl, Params);
  except
    on E: Exception do Result := e.Message;
  end;
  Params.Free;

end;




end.
